whoa = {}
cfg = {}

-- whoa default settings.
local function defaultSettings()
	if (cfg.smallAuraSize == nil) then cfg.smallAuraSize = 20; end
	if (cfg.largeAuraSize == nil) then cfg.largeAuraSize = 25; end
	if (cfg.classColor == nil) then cfg.classColor = true; end
	if (cfg.reactColor == nil) then cfg.reactColor = true; end
	if (cfg.blizzColors == nil) then cfg.blizzColors = false; end
	if (cfg.comboPointFrame == nil) then cfg.comboPointFrame = false; end
	if (cfg.threatNumericIndicator == nil) then cfg.threatNumericIndicator = false;	end
	if (cfg.usePartyFrames == nil) then cfg.usePartyFrames = true; end
	if (cfg.showPartyPets == nil) then cfg.showPartyPets = false; end
	if (cfg.bigAuras == nil) then cfg.bigAuras = true; end
	if (cfg.useBossFrames == nil) then cfg.useBossFrames = true; end
	if (cfg.whoaTexture == nil) then cfg.whoaTexture = true; end
	if (cfg.noClickFrame == nil) then cfg.noClickFrame = false;	end
end

local function currentSetting()
	if ( cfg.classColor==true) then whoaCheckButton2:SetChecked(true) end
	if ( cfg.reactColor == true ) then whoaCheckButton3:SetChecked(true)	end
	if ( cfg.blizzColors == true) then whoaCheckButton4:SetChecked(true) end
	if ( cfg.bigAuras == true) then whoaCheckButton5:SetChecked(true) end
	if ( cfg.usePartyFrames == true) then whoaCheckButton6:SetChecked(true)	end	
	if ( cfg.whoaTexture == true) then whoaCheckButton7:SetChecked(true) end
	if ( cfg.comboPointFrame == true) then whoaCheckButton8:SetChecked(true) end
	if ( cfg.threatNumericIndicator == true) then whoaCheckButton9:SetChecked(true) end
	if ( cfg.showPartyPets == true) then whoaCheckButton10:SetChecked(true) end
	-- if ( cfg.useBossFrames == true) then whoaCheckButton9:SetChecked(true) end
	if (cfg.noClickFrame == true) then whoaCheckButton11:SetChecked(true) end
end

-- Font strings factory
function whoa:CreateFont(frame, name, text, x, y, font, size )
	if size == nil then size = 15 end
	if font == nil then font = STANDARD_TEXT_FONT end
local fontString = frame:CreateFontString(name) fontString:SetPoint("TOPLEFT", x, y) fontString:SetFont(font, size, "") fontString:SetText(text)
return (fontString)
end

-- Checkbuttons factory.
local uniquealyzer = 1;
local function createCheckbutton(parent, x_loc, y_loc, displayname)
	uniquealyzer = uniquealyzer + 1;
	local checkbutton = CreateFrame("CheckButton", "whoaCheckButton" .. uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	return checkbutton;
end

-- Buttons factory.
function whoa:CreateButton(frame, name, text, width, height, x, y, template)
if (template == nil) then template = "OptionsButtonTemplate"
end
local button = CreateFrame("Button", name, frame, template) button:SetPoint("TOPLEFT", x, y) button:SetWidth(width)
button:SetHeight(height) button:SetText(text)
return (button)
end
	
--	Options panel frame
optionUI = {}
optionUI.panel = CreateFrame( "Frame", "optionUI", UIParent );
optionUI.panel.name = "whoa UnitFrames";
InterfaceOptions_AddCategory(optionUI.panel);

--	Option panel frame.
function whoa:optionsPanel()
	local title = whoa:CreateFont(optionUI.panel, "title", "whoa ThickFrames v1.6a", 15, -18, font, 15)
	title:SetFontObject(GameFontNormal) 
	title:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)
	local disclaimer = whoa:CreateFont(optionUI.panel, "disclaimer", "Most options require a reload (/rl) for correct aplication of changes.", 15, -40, font, 12)
	disclaimer:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)

	local xOffset = -80;
	--	Class colors.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset, "Class Color HP.");
	myCheckButton.tooltip = "Displays class colored HP bars on player frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton2:GetChecked() then
			cfg.classColor = true;
		else
			cfg.classColor = false;
		end
	end );
	--	Reaction colors
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-30, "Reaction colored HP bars.");
	myCheckButton.tooltip = "Display unit´s reaction colored HP bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton3:GetChecked() then
			cfg.reactColor = true;
		else
			cfg.reactColor = false;
			cfg.blizzColors = false;
			whoaCheckButton4:SetChecked(false);
		end
	end );
	--	Bright reaction colors.
	myCheckButton = createCheckbutton(optionUI.panel, 280, xOffset-30, " Bright reaction colors.");
	myCheckButton.tooltip = "Displays bright reaction colors on non-player enemies HP bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton4:GetChecked() then
			cfg.reactColor = true;
			cfg.blizzColors = true;
			whoaCheckButton3:SetChecked(true);
		else
			cfg.blizzColors = false;
			whoaCheckButton4:SetChecked(false);
		end
	end );
	--	Aura size.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-60, "Enlarge auras.");
	myCheckButton.tooltip = "Displays bigger debuffs on enemy frames and buffs on allied frames to 4 in a row.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton5:GetChecked() then
			cfg.largeAuraSize = 28			--	max row width is 122. This is 4 buffs in a row.
			cfg.smallAuraSize = 24
			cfg.bigAuras = true;
		else
			cfg.largeAuraSize = 21			--	default size. This is 5 in a row.
			cfg.smallAuraSize = 17
			cfg.bigAuras = false;
		end
	end );
	--	Party frames.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-90, "whoa´s party frame style.");
	myCheckButton.tooltip = "Use whoa´s party frames style when not using Compact Raid Frames. Works for whoa´s and Blizzard´s default frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton6:GetChecked() then
			cfg.usePartyFrames = true;
		else
			cfg.usePartyFrames = false;
		end
	end );
	--	Statusbar textures.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-120, "whoa´s Legacy status texture.");
	myCheckButton.tooltip = "Use whoa´s legacy texture on status bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton7:GetChecked() then
			cfg.whoaTexture = true;
		else
			cfg.whoaTexture = false;
		end
	end );

	local fancyOptions = whoa:CreateFont(optionUI.panel, "fancyOptions", "Other fancy options.", 15, xOffset-160, font, 12)
	fancyOptions:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)
	--	Combo point switch.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-190, "Legacy combo points on target frame.");
	myCheckButton.tooltip = "Re-enables Wow´s old default combo point bar on target frame. Does not hides player frame´s combo points or personal resource bar (Rogues and druids only).";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton8:GetChecked() then
			SetCVar("comboPointLocation",1)
			cfg.comboPointFrame = true;
		else
			SetCVar("comboPointLocation",2)
			cfg.comboPointFrame = false;
		end
	end );
	--	Old threat numeric indicator.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-220, "Legacy threat numeric indicator.");
	myCheckButton.tooltip = "Re-enables Wow´s old default threat numeric indicator which shows current´s target threat over ";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton9:GetChecked() then
			SetCVar("threatShowNumeric",1)
			cfg.threatNumericIndicator = true;
		else
			SetCVar("threatShowNumeric",0)
			cfg.threatNumericIndicator = false;
		end
	end );
	--	Pets on party frames.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-250, "Show pets on party frames.");
	myCheckButton.tooltip = "Show pets on party frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton10:GetChecked() then
			SetCVar("showPartyPets",1)
			cfg.showPartyPets = true;
		else
			SetCVar("showPartyPets",0)
			cfg.showPartyPets = false;
		end
	end );
	--	Click interaction switch.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-370, "Disable mouse clicks over player and target frames.");
	-- myCheckButton:SetEnabled(false);
	myCheckButton.tooltip = "Disable mouse clicks over player and target frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton11:GetChecked() then
			cfg.noClickFrame = true;
			disableFramesClick()
		else
			cfg.noClickFrame = false;
			disableFramesClick()
		end
	end );
	
	-- Frames centering / restore.
	local positionOptions = whoa:CreateFont(optionUI.panel, "mainOptions", "Positioning options.", 25, xOffset-350, font, 13)
	mainOptions:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)
	local centerBttnInfo = whoa:CreateFont(optionUI.panel, "centerBttnInfo", "Center player and target frames middle screen.", 50, -500, font, 12)
	mainOptions:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)
	local centerBttn = CreateFrame("Button", "centerButton", optionUI.panel, "UIPanelButtonTemplate")
	centerBttn:SetSize(110 ,25)
	centerBttn:SetText("Center frames")
	centerBttn:SetPoint("BOTTOMLEFT",70,20)
	centerBttn:SetScript("OnClick", function()
		local x,y = -20,-150 for i,f in pairs({PlayerFrame,TargetFrame}) do f:ClearAllPoints() f:SetPoint(i==1 and "RIGHT" or "LEFT",UIParent,"CENTER",i==1 and x or -x,y) f:SetUserPlaced(true) end
	end)
	-- Reset.
	local resetBttn = CreateFrame("Button", "resetButton", optionUI.panel, "UIPanelButtonTemplate")
	resetBttn:SetSize(100 ,25)
	resetBttn:SetText("Reset frames")
	resetBttn:SetPoint("BOTTOMLEFT",210,20)
	resetBttn:SetScript("OnClick", function()
		PlayerFrame_ResetUserPlacedPosition()
		TargetFrame_ResetUserPlacedPosition()
	end)
	-- Reload
	local reloadBttn = CreateFrame("Button", "reloadButton", optionUI.panel, "UIPanelButtonTemplate")
		reloadBttn:SetSize(80 ,22)
		reloadBttn:SetText("Reload UI")
		reloadBttn:SetPoint("BOTTOMRIGHT",-20,20)
		reloadBttn:SetScript("OnClick", function()
		ReloadUI()
	end)
end

-- slash commands.
SlashCmdList.optionUI = function()
	InterfaceOptionsFrame_OpenToCategory(optionUI.panel)
	InterfaceOptionsFrame_OpenToCategory(optionUI.panel)
end

SLASH_optionUI1 = "/optionUI"
SLASH_optionUI1 = "/wuf"
SLASH_optionUI1 = "/whoa"

SlashCmdList['RELOAD'] = function() ReloadUI() end
SLASH_RELOAD1 = '/rl'

whoa:optionsPanel()
--	Events
function whoa:Init(event, addon, ...)
	if (event == "ADDON_LOADED" and addon == "whoaThickFrames") then
		defaultSettings()
		print("|cff00ccff [WhoaThockFrames] v1.6a |cff888888is now loaded. Use |cffffff00'/whoa' |cff888888to view options.")
	end
	if (event == "PLAYER_ENTERING_WORLD")  then
		currentSetting()
		disableFramesClick()
	end
end
-- create addon frame
local optionUI = CreateFrame("Frame", "optionUI", UIParent)
optionUI:SetScript("OnEvent", whoa.Init)
optionUI:RegisterEvent("ADDON_LOADED")
optionUI:RegisterEvent("PLAYER_ENTERING_WORLD")
-- optionUI:RegisterEvent("PLAYER_ENTER_COMBAT")
-- optionUI:RegisterEvent("PLAYER_LEAVE_COMBAT")
-- optionUI:RegisterEvent("PLAYER_REGEN_DISABLED")
-- optionUI:RegisterEvent("PLAYER_REGEN_ENABLED")