--	Target frame
function whoaTargetFrames (self, forceNormalTexture)
	local classification = UnitClassification(self.unit);
	self.highLevelTexture:SetPoint("CENTER", self.levelText, "CENTER", 0,0);
	self.deadText:SetPoint("CENTER", self.healthbar, "CENTER",0,0);
	self.unconsciousText:SetPoint("CENTER", self.healthbar, "CENTER",0,0);
	self.nameBackground:Hide();
	self.threatIndicator:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Flash");
	self.name:SetPoint("LEFT", self, 15, 36);
	self.healthbar:SetSize(119, 28);
	self.healthbar:SetPoint("TOPLEFT", 5, -24);
	self.healthbar.LeftText:SetPoint("LEFT", self.healthbar, "LEFT", 5, 0);
	self.healthbar.TextString:SetPoint("CENTER", self.healthbar, "CENTER", 0, 0);
	self.manabar.LeftText:SetPoint("LEFT", self.manabar, "LEFT", 3, 0);
	self.manabar.RightText:SetPoint("RIGHT", self.manabar, "RIGHT", -3, 0);
	self.manabar.TextString:SetPoint("CENTER", self.manabar, "CENTER", 0, 0);
	TargetFrame.threatNumericIndicator:SetPoint("BOTTOM", PlayerFrame, "TOP", 72, -21);
	FocusFrame.threatNumericIndicator:SetAlpha(0);
	if ( forceNormalTexture ) then
		self.borderTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame");
	elseif ( classification == "minus" ) then
		self.borderTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Minus");
		forceNormalTexture = true;
	elseif ( classification == "worldboss" or classification == "elite" ) then
		self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames\\media\\UI-TargetingFrame-Elite");
	elseif ( classification == "rareelite" ) then
		self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames\\media\\UI-TargetingFrame-Rare-Elite");
	elseif ( classification == "rare" ) then
		self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames\\media\\UI-TargetingFrame-Rare");
	else
		self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames\\media\\UI-TargetingFrame");
		forceNormalTexture = true;
	end
	if ( forceNormalTexture ) then
		self.haveElite = nil;
		if ( classification == "minus" ) then
			self.Background:SetSize(119,12);
			self.Background:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT", 7, 47);
			self.name:SetPoint("LEFT", self, 16, 19);
			self.healthbar:ClearAllPoints();
			self.healthbar:SetPoint("LEFT", 5, 3);
			self.healthbar:SetHeight(12);
			self.healthbar.LeftText:SetPoint("LEFT", self.healthbar, "LEFT", 3, 0);
			self.healthbar.RightText:SetPoint("RIGHT", self.healthbar, "RIGHT", -2, 0);
		else
			self.Background:SetSize(119,42);
			self.Background:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT", 7, 35);
		end
		if ( self.threatIndicator ) then
			if ( classification == "minus" ) then
				self.threatIndicator:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Minus-Flash");
				self.threatIndicator:SetTexCoord(0, 1, 0, 1);
				self.threatIndicator:SetWidth(256);
				self.threatIndicator:SetHeight(128);
				self.threatIndicator:SetPoint("TOPLEFT", self, "TOPLEFT", -24, 0);
			else
				self.threatIndicator:SetTexCoord(0, 0.9453125, 0, 0.181640625);
				self.threatIndicator:SetWidth(242);
				self.threatIndicator:SetHeight(93);
				self.threatIndicator:SetPoint("TOPLEFT", self, "TOPLEFT", -24, 0);
			end
		end	
	else
		self.haveElite = true;
		self.Background:SetSize(119,42);
		if ( self.threatIndicator ) then
			self.threatIndicator:SetTexCoord(0, 0.9453125, 0.181640625, 0.400390625);
			self.threatIndicator:SetWidth(242);
			self.threatIndicator:SetHeight(112);
		end		
	end
	if (self.questIcon) then
		if (UnitIsQuestBoss(self.unit)) then
			self.healthbar.RightText:SetPoint("RIGHT", self.healthbar, "RIGHT", -9, 0);
		else
			self.healthbar.RightText:SetPoint("RIGHT", self.healthbar, "RIGHT", -3, 0);
		end
	end
	if ( cfg.whoaTexture == true) then
		self.healthbar:SetStatusBarTexture("Interface\\Addons\\whoaThickFrames\\media\\statusbar\\whoa");
	end
end
hooksecurefunc("TargetFrame_CheckClassification", whoaTargetFrames)

-- Mana texture
function whoaManaBar (manaBar)
	local powerType, powerToken, altR, altG, altB = UnitPowerType(manaBar.unit);
	local info = PowerBarColor[powerToken];
	if ( info ) then
		if ( not manaBar.lockColor ) then
			if not ( info.atlas ) and ( cfg.whoaTexture == true) then
				manaBar:SetStatusBarTexture("Interface\\Addons\\whoaThickFrames\\media\\statusbar\\whoa");
			end
		end
	end
end
hooksecurefunc("UnitFrameManaBar_UpdateType", whoaManaBar)

--	ToT & ToF
function whoaFrameToTF()
	TargetFrameToTTextureFrameDeadText:ClearAllPoints();
	TargetFrameToTTextureFrameDeadText:SetPoint("CENTER", "TargetFrameToTHealthBar","CENTER",1, 0);
	TargetFrameToTTextureFrameName:SetSize(65,10);
	TargetFrameToTTextureFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames\\media\\UI-TargetofTargetFrame");
	TargetFrameToTHealthBar:ClearAllPoints();
	TargetFrameToTHealthBar:SetPoint("TOPLEFT", 45, -15);
    TargetFrameToTHealthBar:SetHeight(10);
    TargetFrameToTManaBar:ClearAllPoints();
    TargetFrameToTManaBar:SetPoint("TOPLEFT", 45, -25);
    TargetFrameToTManaBar:SetHeight(5);
	FocusFrameToTTextureFrameDeadText:ClearAllPoints();
	FocusFrameToTTextureFrameDeadText:SetPoint("CENTER", "FocusFrameToTHealthBar" ,"CENTER",1, 0);
	FocusFrameToTTextureFrameName:SetSize(65,10);
	FocusFrameToTTextureFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames\\media\\UI-TargetofTargetFrame");
	FocusFrameToTHealthBar:ClearAllPoints();
    FocusFrameToTHealthBar:SetPoint("TOPLEFT", 43, -15);
    FocusFrameToTHealthBar:SetHeight(10);
    FocusFrameToTManaBar:ClearAllPoints();
    FocusFrameToTManaBar:SetPoint("TOPLEFT", 43, -25);
    FocusFrameToTManaBar:SetHeight(5);
end
hooksecurefunc("TargetFrame_CheckClassification", whoaFrameToTF)

-- --	Boss target frames disabled due to taint.
-- function whoaBossFrames()
	-- for i = 1, MAX_BOSS_FRAMES do
		-- _G["Boss"..i.."TargetFrameTextureFrameDeadText"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameTextureFrameDeadText"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrameHealthBar"],"CENTER",0,0);
		-- _G["Boss"..i.."TargetFrameTextureFrameName"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameTextureFrameName"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrameManaBar"],"CENTER",0,0);
		-- _G["Boss"..i.."TargetFrameTextureFrameTexture"]:SetTexture("Interface\\Addons\\whoaThickFrames\\media\\UI-UNITFRAME-BOSS");
		-- _G["Boss"..i.."TargetFrameNameBackground"]:SetAlpha(0);
		-- _G["Boss"..i.."TargetFrameHealthBar"]:SetSize(116,18);
		-- _G["Boss"..i.."TargetFrameHealthBar"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameHealthBar"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrame"],"CENTER",-51,18);
		-- _G["Boss"..i.."TargetFrameManaBar"]:SetSize(116,18);
		-- _G["Boss"..i.."TargetFrameManaBar"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameManaBar"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrame"],"CENTER",-51,-3);
		-- _G["Boss"..i.."TargetFrameTextureFrameHealthBarTextLeft"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameTextureFrameHealthBarTextLeft"]:SetPoint("LEFT",_G["Boss"..i.."TargetFrameHealthBar"],"LEFT",0,0);
		-- _G["Boss"..i.."TargetFrameTextureFrameHealthBarTextRight"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameTextureFrameHealthBarTextRight"]:SetPoint("RIGHT",_G["Boss"..i.."TargetFrameHealthBar"],"RIGHT",0,0);
		-- _G["Boss"..i.."TargetFrameTextureFrameHealthBarText"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameTextureFrameHealthBarText"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrameHealthBar"],"CENTER",0,0);
		-- _G["Boss"..i.."TargetFrameTextureFrameManaBarTextLeft"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameTextureFrameManaBarTextLeft"]:SetPoint("LEFT",_G["Boss"..i.."TargetFrameManaBar"],"LEFT",0,0);
		-- _G["Boss"..i.."TargetFrameTextureFrameManaBarTextRight"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameTextureFrameManaBarTextRight"]:SetPoint("RIGHT",_G["Boss"..i.."TargetFrameManaBar"],"RIGHT",0,0);
		-- _G["Boss"..i.."TargetFrameTextureFrameManaBarText"]:ClearAllPoints();
		-- _G["Boss"..i.."TargetFrameTextureFrameManaBarText"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrameManaBar"],"CENTER",0,0);
	-- end
-- end
-- whoaBossFrames();

-- *********************************************************************************
-- Boss Frames
-- *********************************************************************************

-- function BossTargetFrame_OnLoad(self, unit, event)
	-- --
	-- -- self.nameBackground:Hide();
	-- self.healthbar:SetSize(116,18);

	-- --
	-- self.isBossFrame = true;
	-- self.noTextPrefix = true;
	-- self.showLevel = true;
	-- self.showThreat = true;
	-- self.maxBuffs = 0;
	-- self.maxDebuffs = 0;
	-- TargetFrame_OnLoad(self, unit, BossTargetFrameDropDown_Initialize);
	-- self:RegisterEvent("UNIT_TARGETABLE_CHANGED");
	-- self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames\\media\\UI-UNITFRAME-BOSS");
	-- self.levelText:SetPoint("CENTER", 12, select(5, self.levelText:GetPoint("CENTER")));
	-- self.raidTargetIcon:SetPoint("RIGHT", -90, 0);
	-- self.threatNumericIndicator:SetPoint("BOTTOM", self, "TOP", -85, -22);
	-- self.threatIndicator:SetTexture("Interface\\TargetingFrame\\UI-UnitFrame-Boss-Flash");
	-- self.threatIndicator:SetTexCoord(0.0, 0.945, 0.0, 0.73125);
	-- self:SetHitRectInsets(0, 95, 15, 30);
	-- self:SetScale(0.75);
	-- if ( event ) then
		-- self:RegisterEvent(event);
	-- end
-- end
-- BossTargetFrame_OnLoad("Boss1TargetFrame")


-- function BossTargetFrameDropDown_Initialize(self)
	-- UnitPopup_ShowMenu(self, "BOSS", self:GetParent().unit);
-- end

-- function whoaBossFramesText()
		-- for i = 1, MAX_BOSS_FRAMES do
			-- _G["Boss"..i.."TargetFrameTextureFrameManaBarTextLeft"]:SetText(" ");
			-- _G["Boss"..i.."TargetFrameTextureFrameManaBarTextRight"]:SetText(" ");
			-- _G["Boss"..i.."TargetFrameTextureFrameManaBarText"]:SetText(" ");
		-- end
-- end
-- hooksecurefunc("TextStatusBar_UpdateTextStringWithValues", whoaBossFramesText)